using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Eco.Handles;
using Eco.Windows.Forms;
using Eco.WinForm;
using Eco.ObjectRepresentation;
using Eco.Services;

using EcoMvcExample.Model;


namespace EcoMvcExample_Admin
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public partial class ProgramStart : System.Windows.Forms.Form
	{

        public ProgramStart(EcoMvcExample.EcoMvcExampleEcoSpace ecoSpace)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// Set EcoSpace (actually stores it in rhRoot.EcoSpace)
			// Note that you need to set the EcoSpace property for 
			// each ReferenceHandle and VariableHandle you add to 
			// the form.
			rhRoot.EcoSpace = ecoSpace;
		}

        public EcoMvcExample.EcoMvcExampleEcoSpace EcoSpace
		{
			get { return (EcoMvcExample.EcoMvcExampleEcoSpace)rhRoot.EcoSpace; }
		}

        private void btnAddUser_Click(object sender, EventArgs e)
        {
            new TaskUser(EcoSpace);
        }

        private void btnDeleteUser_Click(object sender, EventArgs e)
        {
            if (cmhCurrentUser.Element != null)
            {
                TaskUser curUser = cmhCurrentUser.Element.AsObject as TaskUser;
                if (curUser != null)
                {
                    curUser.AsIObject().Delete();
                }
            }
        }

        private void btnAddTask_Click(object sender, EventArgs e)
        {
            if (cmhCurrentUser.Element != null)
            {
                TaskUser curUser = cmhCurrentUser.Element.AsObject as TaskUser;
                if (curUser != null)
                {
                    Task assignment = new Task(EcoSpace);
                    assignment.User = curUser;
                    assignment.DateEntered = DateTime.Now;
                    assignment.Name = "New Task";
                    assignment.Completed = false;
                }
            }
        }

        private void btnDeleteCurrentTask_Click(object sender, EventArgs e)
        {
            if (cmhCurrentTask.Element != null)
            {
                IObject oiCurrent = cmhCurrentTask.Element as IObjectInstance;
                oiCurrent.Delete();
            }
        }
	}
}
