﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using Rhino.Mocks;
using System.Web.Mvc;
using System.Web.Routing;

namespace EcoMvcExample.MvcWebsite.Tests.Controllers
{
    public class MockHttpContext : HttpContextBase
    {
        public HttpRequestBase MockRequest;
        public HttpResponseBase MockResponse;
        public HttpServerUtilityBase MockServer;
        public HttpSessionStateBase MockSession;

        public MockHttpContext(MockRepository mocks)
        {
            MockRequest = mocks.PartialMock<HttpRequestBase>();
            MockResponse = mocks.PartialMock<HttpResponseBase>();
            MockServer = mocks.PartialMock<HttpServerUtilityBase>();
            MockSession = mocks.PartialMock<HttpSessionStateBase>();
        }

        public override HttpRequestBase Request
        {
            get { return MockRequest; }
        }

        public override HttpResponseBase Response
        {
            get { return MockResponse; }
        }

        public override HttpServerUtilityBase Server
        {
            get { return MockServer; }
        }

        public override HttpSessionStateBase Session
        {
            get { return MockSession; }
        }

        public void DoPostRecordInitialization(Controller controller)
        {
            controller.ControllerContext = new ControllerContext(this, new RouteData(), controller);
        }

    }
}