﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using NUnit.Framework;

using EcoMvcExample.Model;
using EcoMvcExample.MvcWebsite.Models;


namespace EcoMvcExample.MvcWebsite.Tests.Models
{
    [TestFixture]
    public class TaskHelperTests
    {
        // test variables
        TestMemoryEcoSpace ecoSpace = null;


        [SetUp]
        public void SetupEnvironment()
        {
            ecoSpace = new TestMemoryEcoSpace();
            ecoSpace.Active = true;
        }

        [TearDown]
        public void TearDownEnvironment()
        {
            ecoSpace = null;
        }

        [Test]
        public void GetAllTasks()
        {
            // Create the test objects.
            TestObjectsHelper.CreateTestObjects(this.ecoSpace, true);

            // Try to work against the test objects.
            IList<Task> tasks = TaskHelper.GetAllTasks(this.ecoSpace);
            Assert.IsNotNull(tasks, "GetAllTasks returned null!");
            Assert.AreEqual(4, tasks.Count, "GetAllTasks returned a number different to that expected!");
        }

        [Test]
        public void GetUsersTasks()
        {
            // Create the test objects.
            TestObjectsHelper.CreateTestObjects(this.ecoSpace, true);

            // Try to work against the test objects.
            IList<Task> test1tasks = TaskHelper.GetUserTasks(this.ecoSpace, "test1");
            Assert.IsNotNull(test1tasks, "GetUserTasks returned null for user test1!");
            Assert.AreEqual(2, test1tasks.Count, "GetUserTasks returned an incorrect number of tasks for test1!");

            IList<Task> test2tasks = TaskHelper.GetUserTasks(this.ecoSpace, "test2");
            Assert.IsNotNull(test2tasks, "GetUserTasks returned null for user test2!");
            Assert.AreEqual(2, test2tasks.Count, "GetUserTasks returned an incorrect number of tasks for test2!");
        }
    }
}