﻿using System;
using System.Collections.Generic;

using Eco.Persistence;
using Eco.Persistence.Xml;
using Eco.Services;

using EcoMvcExample;


namespace EcoMvcExample.MvcWebsite.Tests
{
    /// <summary>
    /// This is a Memory alternate EcoSpace to allow for faster running of tests, as well
    /// as not strictly speaking persisting any data, although that too can be faked/mocked,
    /// making it ideal for testing without issue of affecting live data.
    /// </summary>
    internal class TestMemoryEcoSpace : EcoMvcExampleEcoSpace
    {
        public TestMemoryEcoSpace(): base()
        {
            PersistenceMapper = new PersistenceMapperMemory();
        }

        public new void UpdateDatabase()
        {
            IPersistenceService ps = GetEcoService<IPersistenceService>();
            IDirtyListService dls = GetEcoService<IDirtyListService>();
            ps.UpdateDatabaseWithList(dls.AllDirtyObjects());
        }
    }
}
