﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;

// Our added uses
using Community.Eco.Web.Mvc;
using EcoMvcExample.Model;
using EcoMvcExample.MvcWebsite.Models;
using System.Security.Principal;


namespace EcoMvcExample.MvcWebsite.Controllers
{
    public class EcoMvcExampleBaseController : EcoController
    {
        public EcoMvcExampleBaseController()
        {
            EcoSpaceType = typeof(EcoMvcExampleEcoSpace);
        }


        // A routine to set the appropriate view data parameter should this user be authenticated
        // allowing us to determine if we this user is able to create tasks.
        protected void CheckIfUserCanCreateTasks()
        {
            if (Request != null)
            {
                if (Request.IsAuthenticated)
                {
                    IIdentity ident = User.Identity;
                    string sUsername = ident.Name;

                    TaskUser currentUser = TaskUserHelper.GetUser(this.EcoSpace, sUsername);
                    if (currentUser != null)
                    {
                        ViewData[EcoMvcExample.MvcWebsite.SiteConstants.ViewData.CanCreateTasks] = currentUser.CanCreateTasks;
                    }
                    else
                    {
                        ViewData[SiteConstants.ViewData.CanCreateTasks] = false;
                    }
                }
                else
                {
                    ViewData[SiteConstants.ViewData.CanCreateTasks] = false;
                }
            }
            else
            {
                ViewData[SiteConstants.ViewData.CanCreateTasks] = false;
            }
        }
    }
}
