﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;

// Our added uses
using EcoMvcExample.MvcWebsite;


namespace EcoMvcExample.MvcWebsite.Controllers
{
    /// <summary>
    /// This controller inherits from the base Eco controller we created to allow any controller
    /// to have access to an EcoSpace.  In this case, we also have added a method to it called
    /// CheckIfUserCanCreateTasks() and allowed this to be called by inheriting classes.
    /// </summary>
    [HandleError]
    public class HomeController : EcoMvcExampleBaseController
    {
        public ActionResult Index()
        {
            ViewData["Title"] = "Home Page";
            ViewData["Message"] = "Welcome to ASP.NET MVC!";
            CheckIfUserCanCreateTasks();
            
            // Return the "Home" Page View
            return View();
        }

        public ActionResult About()
        {
            ViewData["Title"] = "About Page";
            CheckIfUserCanCreateTasks();

            // Return the "About this Example" Page View
            return View();
        }
    }
}
