﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="LoginUserControl.ascx.cs" Inherits="EcoMvcExample.MvcWebsite.Views.Shared.LoginUserControl" %>
<%@ Register Assembly="Microsoft.Web.Mvc, Version=1.0.31003.0, Culture=neutral" Namespace="Microsoft.Web.Mvc" TagPrefix="mvc" %>
<%@ Register Namespace="EcoMvcExample.MvcWebsite.Controllers" TagPrefix="mvc" %>
<%
    if (Request.IsAuthenticated) {
%>
        Welcome <b><%= Html.Encode(Page.User.Identity.Name) %></b>!
        <%-- Just a quick comment about options here.  You can use just strings, as you can see in one example here,
             to specify the appropriate controller, and action, but it is dependant on human typing accuracy.
             
             A better way to achieve this is in the first example, which is a strongly typed example.
             LinkBuilder or LinkExtensions method BuildUrlFromExpression is another good option.             
             This method creates the call URL from the LINQ expression, which is a strongly typed expression.
             When entered in code, the expression is compiler checked, and strongly typed providing code stuffy
             on available methods/actions, which in this case is the Action Login()
             
             Html.ActionLink creates the link tag, based on the parameters provided, which sadly are all strings.
             
             However, the newly added Html.ActionLink<ControllerClassName>() method does exactly what we would like
             by providing a complete link, based on the LINQ expression automatically resolving to the correct method
             name strongly, whilst allowing us to pass some text for the link in as well. --%>
             
        [ <%= Html.ActionLink<AccountController>(ac => ac.Logout(), "Logout") %> ]
<%
    }
    else {
%> 
        <%-- This is an example of the original way this was called:
        
        Html.ActionLink("Login", "Login", "Account")
        
        Which I modified to do this, calling a property which provided a get method which constructed the Url
        based on a LINQ expression in code, providing a strongly typed and compile time tested result.
        
        [ <a href='<%= this.LoginUrl %>'>Login Here</a> ]
        
        However, I recently replaced this with a call to the generic based Html.ActionLink<> call instead: --%>
        [ <%= Html.ActionLink<AccountController>(ac => ac.Login(), "Login Here") %> ]
<%
    }
%>
