﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.UI;
using System.IO;

using EcoMvcExample.MvcWebsite.Controllers;
using EcoMvcExample.MvcWebsite.Models;
using EcoMvcExample.Model;
using Microsoft.Web.Mvc;
using System.Security.Principal;


namespace EcoMvcExample.MvcWebsite.Views.Shared
{
    public partial class Site : System.Web.Mvc.ViewMasterPage
    {
        public string CanCreateOption
        {
            get
            {
                if (Request.IsAuthenticated)
                {
                    // Try to get this users object, and check if they can create Tasks
                    EcoMvcExampleEcoSpace espace = EcoHelper.GetEcospace();
                    if (espace != null)
                    {
                        if (Page.User.Identity != null)
                        {
                            IIdentity ident = Page.User.Identity;
                            string sUsername = ident.Name;

                            TaskUser ecoUser = TaskUserHelper.GetUser(espace, sUsername);
                            if (ecoUser.CanCreateTasks)
                            {
                                return CreateTasksMenuItem;
                            }
                            else
                                return string.Empty;
                        }
                        else
                            return string.Empty;
                    }
                    else
                        return string.Empty;
                }
                else
                    return string.Empty;
            }
        }

        public string CreateTasksMenuItem
        {
            get
            {
                string sReturnValue = null;
                StringWriter sw = new StringWriter();
                try
                {
                    XhtmlTextWriter xw = new XhtmlTextWriter(sw);
                    try
                    {
                        xw.RenderBeginTag(HtmlTextWriterTag.Li);
                        try
                        {
                            string sLink = Html.ActionLink<TasksController>(tc => tc.Create(), "Create Task");
                            xw.Write(sLink);
                        }
                        finally
                        {
                            xw.RenderEndTag();
                        }
                    }
                    finally
                    {
                        xw = null;
                    }
                }
                finally
                {
                    sReturnValue = sw.ToString();
                    sw = null;
                }

                return sReturnValue;
            }
        }
    }
}
